#include "SigFlag.hh"
#include "Interval.hh"
#include "Time.hh"
#include "lsmp_con.hh"
#include <iostream>
#include <cmath>

using namespace std;

int
main(int argc, const char* argv[]) {
  SigFlag mTerm(SIGTERM);
  mTerm.add(SIGINT);
  mTerm.zero();

  const int nAvg = 10;

  const char* part="LHO_Online";
  if (argc > 1) part = argv[argc-1];
  LSMP_CON cons(part);

  double Avg(0.0), Sig(0.0);
  int    iAvg(0);
  while (!mTerm) {
    cons.get_buffer();
    Time t=Time(cons.getEvtID());
    cons.free_buffer();
    double dt = double(Now() - t);
    Avg += dt;
    Sig += dt*dt;
    if (++iAvg >= nAvg) {
      Avg /= double(iAvg);
      Sig  = Sig / double(iAvg) - Avg * Avg;
      if (Sig <= 0) Sig = 0;
      else          Sig = sqrt(Sig);
      cout << "Average Latency = " << Avg << " sigma = " << Sig << endl;
      Avg = 0; iAvg = 0; Sig = 0;
    }
  }
}
